/* rc4.h -- rc4 interfaces
 * Rob Earhart 
 */
/***********************************************************
        Copyright 1999 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Carnegie Mellon
University not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE FOR
ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
******************************************************************/

#ifndef RC4_H
#define RC4_H

typedef struct {
  unsigned char sbox[256];
  int i, j;
} rc4_context_t;

extern void
rc4_init(rc4_context_t *context,
	 const unsigned char *key,
	 unsigned keylen);

extern void
rc4_encrypt(rc4_context_t *context,
	    const char *input,
	    char *output,
	    unsigned len);

extern void
rc4_decrypt(rc4_context_t *context,
	    const char *input,
	    char *output,
	    unsigned len);

#endif /* RC4_H */
